/* Tabela TIPOCONSFILI: TABELA TIPO DE CONSUMIDOR POR FILIAL*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela TIPOCONSFILI */
/* Objetivo: Gerar um log que vai registrar as alteraes na TIPOCONSFILI,
             utilizando a tabela de Logs de Operaes do VND*/
CREATE OR REPLACE TRIGGER LOG_VND_TIPOCONSFILI
AFTER DELETE OR INSERT OR UPDATE
ON TIPOCONSFILI FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
  		IF NVL(:NEW.CDFILIAL ,'NULL') <> NVL(:OLD.CDFILIAL ,'NULL') THEN
  			V_DESC   := 'Filial ' || '' || NVL(:NEW.CDFILIAL,''    );
  		END IF;
  		IF NVL(:NEW.CDTIPOCONS ,'NULL') <> NVL(:OLD.CDTIPOCONS ,'NULL') THEN
        V_DESC := NVL(V_DESC, '') || ' ' || 'Tipo Consumidor  '     || '' || NVL(:NEW.CDTIPOCONS,''  );
  		END IF;
  		IF NVL(:NEW.DSACESSOSITE ,'NULL') <> NVL(:OLD.DSACESSOSITE ,'NULL') THEN
        V_DESC := NVL(V_DESC, '') || ' ' || 'Permisso de Acesso '  || '' || NVL(:NEW.DSACESSOSITE,'');
  		END IF;
      IF NVL(:NEW.DSPOSMNUSITE ,'NULL') <> NVL(:OLD.DSPOSMNUSITE ,'NULL') THEN
        V_DESC := NVL(V_DESC, '') || ' ' || 'DSPOSMNUSITE  '     || '' || NVL(:NEW.DSPOSMNUSITE,''  );
      END IF;
      IF NVL(:NEW.CDTIPOCONSEX ,'NULL') <> NVL(:OLD.CDTIPOCONSEX ,'NULL') THEN
        V_DESC := NVL(V_DESC, '') || ' ' || 'CDTIPOCONSEX  '     || '' || NVL(:NEW.CDTIPOCONSEX,''  );
      END IF;
      IF NVL(:NEW.IDRECEBEBONUS ,'NULL') <> NVL(:OLD.IDRECEBEBONUS ,'NULL') THEN
        V_DESC := NVL(V_DESC, '') || ' ' || 'IDRECEBEBONUS  '     || '' || NVL(:NEW.IDRECEBEBONUS,''  );
      END IF;
      IF NVL(:NEW.VRCARGACREDITO ,999999) <> NVL(:OLD.VRCARGACREDITO ,999999) THEN
        V_DESC := NVL(V_DESC, '') || ' ' || 'VRCARGACREDITO ' || ' ' || NVL(:NEW.VRCARGACREDITO,'' );
      END IF;
      IF NVL(:NEW.VRBONUSCREDITO ,999999) <> NVL(:OLD.VRBONUSCREDITO ,999999) THEN
        V_DESC := NVL(V_DESC, '') || ' ' || 'VRBONUSCREDITO ' || ' ' || NVL(:NEW.VRBONUSCREDITO,'' );
      END IF;  
      IF NVL(:NEW.VRSALDCONSBONUS ,999999) <> NVL(:OLD.VRSALDCONSBONUS ,999999) THEN
        V_DESC := NVL(V_DESC, '') || ' ' || 'VRSALDCONSBONUS ' || ' ' || NVL(:NEW.VRSALDCONSBONUS,'' );
      END IF;  
      IF NVL(:NEW.IDPERIODOBONUS ,'NULL') <> NVL(:OLD.IDPERIODOBONUS ,'NULL') THEN
        V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERIODOBONUS  '     || '' || NVL(:NEW.IDPERIODOBONUS,''  );
      END IF;
      IF NVL(:NEW.CDTIPORECE ,'NULL') <> NVL(:OLD.CDTIPORECE ,'NULL') THEN
        V_DESC := NVL(V_DESC, '') || ' ' || 'CDTIPORECE  '     || '' || NVL(:NEW.CDTIPORECE,''  );
      END IF;
      IF NVL(:NEW.QTRECARGASMES ,999999) <> NVL(:OLD.QTRECARGASMES ,999999) THEN
        V_DESC := NVL(V_DESC, '') || ' ' || 'QTRECARGASMES ' || ' ' || NVL(:NEW.QTRECARGASMES,'' );
      END IF;

      V_ITPESQ := :NEW.CDFILIAL||:NEW.CDTIPOCONS;
      V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN
      V_DESC   := 'Filial '               || '' || NVL(:NEW.CDFILIAL,''    )      || ' ' ||
                  'Tipo Consumidor  '     || '' || NVL(:NEW.CDTIPOCONS,''  )      || ' ' ||
                  'DSPOSMNUSITE  '        || '' || NVL(:NEW.DSPOSMNUSITE,''  )    || ' ' ||
                  'CDTIPOCONSEX  '        || '' || NVL(:NEW.CDTIPOCONSEX,''  )    || ' ' ||
                  'IDRECEBEBONUS  '       || '' || NVL(:NEW.IDRECEBEBONUS,''  )   || ' ' ||
                  'VRCARGACREDITO  '      || '' || NVL(:NEW.VRCARGACREDITO,''  )  || ' ' ||
                  'VRBONUSCREDITO  '      || '' || NVL(:NEW.VRBONUSCREDITO,''  )  || ' ' ||                  
                  'VRSALDCONSBONUS  '     || '' || NVL(:NEW.VRSALDCONSBONUS,''  ) || ' ' || 
                  'IDPERIODOBONUS  '      || '' || NVL(:NEW.IDPERIODOBONUS,''  )  || ' ' || 
                  'CDTIPORECE  '          || '' || NVL(:NEW.CDTIPORECE,''  )      || ' ' || 
                  'QTRECARGASMES  '       || '' || NVL(:NEW.QTRECARGASMES,''  )   || ' ' || 
                  'Permisso de Acesso '  || '' || NVL(:NEW.DSACESSOSITE,'')
                  ;
      V_ITPESQ := :NEW.CDFILIAL||:NEW.CDTIPOCONS;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING THEN
      V_DESC   := 'Filial '               || '' || NVL(:OLD.CDFILIAL,''    )      || ' ' ||
                  'Tipo Consumidor  '     || '' || NVL(:OLD.CDTIPOCONS,''  )      || ' ' ||                  
                  'DSPOSMNUSITE  '        || '' || NVL(:OLD.DSPOSMNUSITE,''  )    || ' ' ||
                  'CDTIPOCONSEX  '        || '' || NVL(:OLD.CDTIPOCONSEX,''  )    || ' ' ||
                  'IDRECEBEBONUS  '       || '' || NVL(:OLD.IDRECEBEBONUS,''  )   || ' ' ||
                  'VRCARGACREDITO  '      || '' || NVL(:OLD.VRCARGACREDITO,''  )  || ' ' ||
                  'VRBONUSCREDITO  '      || '' || NVL(:OLD.VRBONUSCREDITO,''  )  || ' ' ||                  
                  'VRSALDCONSBONUS  '     || '' || NVL(:OLD.VRSALDCONSBONUS,''  ) || ' ' || 
                  'IDPERIODOBONUS  '      || '' || NVL(:OLD.IDPERIODOBONUS,''  )  || ' ' || 
                  'CDTIPORECE  '          || '' || NVL(:OLD.CDTIPORECE,''  )      || ' ' || 
                  'QTRECARGASMES  '       || '' || NVL(:OLD.QTRECARGASMES,''  )   || ' ' ||
                  'Permisso de Acesso '  || '' || NVL(:OLD.DSACESSOSITE,'');
      V_ITPESQ := :OLD.CDFILIAL||:OLD.CDTIPOCONS;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERAVND
      (NMTABELAVND,
       DTOPERACAOVND,
       NMRESPOPERVND,
       IDTIPOOPERVND,
       DSOPERACAOVND,
       CDPESQITEMVND,
       DSRDMUSUOPERVND,
       DSENDUSUOPERVND,
       DSNMUSUOPERVND,
       DSMETUSUOPERVND,
       CDORESPOPERVND,
       CDFILLOGOPERVND)
   VALUES
      ('TIPOCONSFILI',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       NVL(V_DESC,' '),
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER,
       NVL(:NEW.CDFILIAL,:OLD.CDFILIAL));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_VND_TIPOCONSFILI','5.20.001'); END;
/
